using Demo.Data.LocalData;
using Demo.domain.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Demo.Data.Repository
{
    public class UserRepositoryImpl
    {
        public UserRepositoryImpl() {

            GetAllUsers = LocalStaticData.users;
        }
        public List<UserLocalEntity> GetAllUsers
        { get; set; }

        public bool RemoveUserByGuid(Guid userGuid)
        {
            UserLocalEntity? userLocal = GetAllUsers
                .Where(x => x.Guid == userGuid).FirstOrDefault();
            if (userLocal == null) return false;

            return GetAllUsers.Remove(userLocal);
        }

        public UserLocalEntity? GetUserByGuid(Guid userGuid) {
            UserLocalEntity? userLocal = GetAllUsers
                    .Where(x => x.Guid == userGuid).FirstOrDefault();
            if (userLocal == null) return null;

            return userLocal;
        }

        public UserLocalEntity? UpdateUser(UserLocalEntity userUpdateLocalEntity) {
            UserLocalEntity? userLocal = GetAllUsers
                    .Where(x => x.Guid == userUpdateLocalEntity.Guid).FirstOrDefault();
            if (userLocal == null) return null;
            userLocal.FIO = userUpdateLocalEntity.FIO;
            userLocal.GroupID = userUpdateLocalEntity.GroupID;
            return userLocal;

        }
    }
}